package mediationpval;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import javax.swing.Timer;

/**
 *
 * @author falk
 * 
 *  Copyright 2012-2014 Carl F. Falk
 * 
 * This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
public class PPFrame extends javax.swing.JFrame {

    /**
     * Creates new form PPFrame
     */
    public PPFrame() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        title = new javax.swing.JLabel();
        inputTitle = new javax.swing.JLabel();
        t1Label = new javax.swing.JLabel();
        t1TextField = new javax.swing.JTextField();
        df1Label = new javax.swing.JLabel();
        df1TextField = new javax.swing.JTextField();
        t2Label = new javax.swing.JLabel();
        t2TextField = new javax.swing.JTextField();
        df2Label = new javax.swing.JLabel();
        df2TextField = new javax.swing.JTextField();
        computeTitle = new javax.swing.JLabel();
        accuracyButton1 = new javax.swing.JRadioButton();
        accuracyButton2 = new javax.swing.JRadioButton();
        computeButton = new javax.swing.JButton();
        pValLabel = new javax.swing.JLabel();
        pValValue = new javax.swing.JLabel();
        progressLabel = new javax.swing.JLabel();
        jProgressBar1 = new javax.swing.JProgressBar();
        methodTitle = new javax.swing.JLabel();
        methodButton1 = new javax.swing.JRadioButton();
        methodButton2 = new javax.swing.JRadioButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("P-value calculator for mediation analysis");

        title.setFont(new java.awt.Font("Lucida Grande", 1, 14));
        title.setText("Partial Posterior P-Value Calculator");

        inputTitle.setFont(new java.awt.Font("Lucida Grande", 1, 13));
        inputTitle.setText("Input");

        t1Label.setText("t or z statistic for Path A:");

        df1Label.setText("df for Model A:");

        t2Label.setText("t or z statistic for Path B:");

        df2Label.setText("df for Model B:");

        computeTitle.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        computeTitle.setText("Computational Accuracy & Speed");

        buttonGroup1.add(accuracyButton1);
        accuracyButton1.setSelected(true);
        accuracyButton1.setText("Good (fast)");

        buttonGroup1.add(accuracyButton2);
        accuracyButton2.setText("Excellent (slow)");

        computeButton.setText("Compute");
        computeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                computeButtonActionPerformed(evt);
            }
        });

        pValLabel.setText("P-Value:");

        pValValue.setText("-----");

        methodTitle.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        methodTitle.setText("Computational Method");

        buttonGroup2.add(methodButton1);
        methodButton1.setSelected(true);
        methodButton1.setText("t-distribution");
        methodButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                methodButton1ActionPerformed(evt);
            }
        });

        buttonGroup2.add(methodButton2);
        methodButton2.setText("Normal approximation");
        methodButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                methodButton2ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(inputTitle))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(t1Label)
                                    .add(df1Label)
                                    .add(t2Label)
                                    .add(df2Label))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(t1TextField)
                                    .add(df1TextField)
                                    .add(t2TextField)
                                    .add(df2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 98, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(layout.createSequentialGroup()
                                    .add(computeButton)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(pValLabel)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(pValValue))
                                .add(progressLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 196, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jProgressBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 206, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(23, 23, 23)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(accuracyButton1)
                                    .add(accuracyButton2)
                                    .add(computeTitle)))
                            .add(layout.createSequentialGroup()
                                .add(18, 18, 18)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(methodButton1)
                                    .add(methodButton2)
                                    .add(methodTitle)))))
                    .add(layout.createSequentialGroup()
                        .add(119, 119, 119)
                        .add(title)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(title)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(inputTitle)
                    .add(computeTitle))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(t1Label)
                    .add(t1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(accuracyButton1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(df1Label)
                    .add(df1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(accuracyButton2))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(t2Label)
                    .add(t2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(methodTitle))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(df2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(df2Label))
                        .add(18, 18, 18)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(computeButton)
                            .add(pValLabel)
                            .add(pValValue))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(progressLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jProgressBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(methodButton1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(methodButton2)))
                .addContainerGap(19, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    PartialPosteriorCalc pp1;
    PartialPosteriorCalc pp2;
    NumberFormat format;
    String method;
    private Timer timer = new Timer(1000, new ActionListener() {

        @Override
        public void actionPerformed(ActionEvent evt) {
            jProgressBar1.setValue(pp1.getProgress() + pp2.getProgress());
            if (pp1.getDone() && pp2.getDone()) {
                timer.stop();
                computeButton.setEnabled(true);
                if(methodButton1.isSelected()){
                    df1TextField.setEnabled(true);
                    df2TextField.setEnabled(true);
                }
                accuracyButton1.setEnabled(true);
                accuracyButton2.setEnabled(true);
                t1TextField.setEnabled(true);
                t2TextField.setEnabled(true);
                methodButton1.setEnabled(true);
                methodButton2.setEnabled(true);                

                jProgressBar1.setValue(jProgressBar1.getMinimum());
                final double output = Math.max(pp1.getpValue(), pp2.getpValue());

                pValValue.setText(format.format(output));

                jProgressBar1.setValue(0);
                progressLabel.setText("");
            }
        }
    });

    private void computeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_computeButtonActionPerformed
        double t1 = Double.parseDouble(t1TextField.getText());
        double t2 = Double.parseDouble(t2TextField.getText());
        int df1 = 0;
        int df2 = 0;
        method="tdist";

        if(methodButton1.isSelected()){
            method="tdist";
            df1 = Integer.parseInt(df1TextField.getText());
            df2 = Integer.parseInt(df2TextField.getText());            
        } else if (methodButton2.isSelected()){
            method="zdist";
        }
        computeButton.setEnabled(false);
        df1TextField.setEnabled(false);
        df2TextField.setEnabled(false);
        accuracyButton1.setEnabled(false);
        accuracyButton2.setEnabled(false);
        methodButton1.setEnabled(false);
        methodButton2.setEnabled(false);
        t1TextField.setEnabled(false);
        t2TextField.setEnabled(false);

        pValValue.setText("----");
        progressLabel.setText("Calculating, please wait");

        if (accuracyButton1.isSelected()) {
            pp1 = new PartialPosteriorCalc(t1, t2, df1, df2, 1000000, 49, -5, 5, 1, 1000000, .999, "SmoothSpline",method);
            pp2 = new PartialPosteriorCalc(t2, t1, df2, df1, 1000000, 49, -5, 5, 1, 1000000, .999, "SmoothSpline",method);
            format = new DecimalFormat("0.000");
        } else if (accuracyButton2.isSelected()) {
            pp1 = new PartialPosteriorCalc(t1, t2, df1, df2, 1000000, 49, -5, 5, 5, 1000000, .999, "SmoothSpline",method);
            pp2 = new PartialPosteriorCalc(t2, t1, df2, df1, 1000000, 49, -5, 5, 5, 1000000, .999, "SmoothSpline",method);
            format = new DecimalFormat("0.0000");
        }



        jProgressBar1.setMinimum(0);
        jProgressBar1.setMaximum(pp1.getnGrid() * pp1.getrep() + pp2.getnGrid() * pp2.getrep());
        jProgressBar1.setStringPainted(true);

        ppThread pp1Thread = new ppThread(pp1);
        ppThread pp2Thread = new ppThread(pp2);

        pp1Thread.start(); // start thread for null1
        pp2Thread.start(); // start thread for null2
        timer.start(); // start timer that updates GUI
    }//GEN-LAST:event_computeButtonActionPerformed

private void methodButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_methodButton2ActionPerformed
    df1TextField.setEnabled(false);
    df2TextField.setEnabled(false);    
}//GEN-LAST:event_methodButton2ActionPerformed

private void methodButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_methodButton1ActionPerformed
    df1TextField.setEnabled(true);
    df2TextField.setEnabled(true);  
}//GEN-LAST:event_methodButton1ActionPerformed

    /**
     * @param args the command line arguments
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton accuracyButton1;
    private javax.swing.JRadioButton accuracyButton2;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JButton computeButton;
    private javax.swing.JLabel computeTitle;
    private javax.swing.JLabel df1Label;
    private javax.swing.JTextField df1TextField;
    private javax.swing.JLabel df2Label;
    private javax.swing.JTextField df2TextField;
    private javax.swing.JLabel inputTitle;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JRadioButton methodButton1;
    private javax.swing.JRadioButton methodButton2;
    private javax.swing.JLabel methodTitle;
    private javax.swing.JLabel pValLabel;
    private javax.swing.JLabel pValValue;
    private javax.swing.JLabel progressLabel;
    private javax.swing.JLabel t1Label;
    private javax.swing.JTextField t1TextField;
    private javax.swing.JLabel t2Label;
    private javax.swing.JTextField t2TextField;
    private javax.swing.JLabel title;
    // End of variables declaration//GEN-END:variables
}

class ppThread extends Thread {

    private PartialPosteriorCalc pp;

    public ppThread(PartialPosteriorCalc ppCalc) {
        this.pp = ppCalc;
    }

    @Override
    public void run() {
        pp.calcpVal();
    }
}